//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "example_dll.h"

//#define MAKE_LOG
//Vypnuty vypisy

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TExample *Example;

//---------------------------------------------------------------------------
__fastcall TExample::TExample(TComponent* Owner)
  : TForm(Owner)
{
}

DWORD PHandleKarty;

//---------------------------------------------------------------------------
void __fastcall TExample::MakeMeasureClick(TObject *Sender)
{
  int i,pocet_kanalu;
  DWord result_;
  DWord buffer[32];
  char* retezec;

  //Nastaveni kanalu
  pocet_kanalu=6; //4 kanaly + 2 citace

  result_=Td_Config_Acquisition(PHandleKarty,0,0,0,pocet_kanalu);
  if(result_!=0)
  {
    //Nepodailo se nakonfigurovat analogove vstupy Td_Config_Acquisition.
    resolve_error(result_);
    return;
  }

  result_=Td_Config_Acquisition(PHandleKarty,1,0,1,pocet_kanalu);
  if(result_!=0)
  {
    //Nepodailo se nakonfigurovat analogove vstupy Td_Config_Acquisition.
    resolve_error(result_);
    return;
  }

  result_=Td_Config_Acquisition(PHandleKarty,2,0,2,pocet_kanalu);
  if(result_!=0)
  {
    //Nepodailo se nakonfigurovat analogove vstupy Td_Config_Acquisition.
    resolve_error(result_);
    return;
  }
  result_=Td_Config_Acquisition(PHandleKarty,3,0,3,pocet_kanalu);
  if(result_!=0)
  {
    //Nepodailo se nakonfigurovat analogove vstupy Td_Config_Acquisition.
    resolve_error(result_);
    return;
  }
  result_=Td_Config_Acquisition(PHandleKarty,256,0,4,pocet_kanalu);
  if(result_!=0)
  {
    //Nepodailo se nakonfigurovat analogove vstupy Td_Config_Acquisition.
    resolve_error(result_);
    return;
  }
  result_=Td_Config_Acquisition(PHandleKarty,257,0,5,pocet_kanalu);
  if(result_!=0)
  {
    //Nepodailo se nakonfigurovat analogove vstupy Td_Config_Acquisition.
    resolve_error(result_);
    return;
  }


  //Konfigurace citace
  result_=Td_Config_ScanCounter(PHandleKarty,0,0);
  if(result_!=0)
  {
    //Nepodailo se nakonfigurovat asovae karty.
    resolve_error(result_);
    return;
  }
  result_=Td_Config_ScanCounter(PHandleKarty,0,1);
  if(result_!=0)
  {
    //Nepodailo se nakonfigurovat asovae karty.
    resolve_error(result_);
    return;
  }

  //Spusteni mereni
  result_=Td_Start_Acquisition(PHandleKarty,1);
  if(result_!=0)
  {
    //Nepodailo se odstartovat men se zadanmi parametry.
    resolve_error(result_);
    return;
  }


  //Posleme si pro data
  result_=Td_Get_SingleAcquisition(PHandleKarty,&buffer[0],pocet_kanalu);
  if(result_!=0)
  {
    //Nepodailo se pest mc vzorek.
    resolve_error(result_);
    return;
  }

  //Nyni zbyva pouze data zobrazit
  Edit1->Text=AnsiString(buffer[0]);
  Edit2->Text=AnsiString(buffer[1]);
  Edit3->Text=AnsiString(buffer[2]);
  Edit4->Text=AnsiString(buffer[3]);
  Edit5->Text=AnsiString(buffer[4]);
  Edit6->Text=AnsiString(buffer[5]);

  result_=Td_Stop_Acquisition(PHandleKarty);
  if(result_!=0)
  {
    //Nepodailo se pest mc vzorek.
    resolve_error(result_);
    return;
  }
}

//---------------------------------------------------------------------------
void __fastcall TExample::FormCreate(TObject *Sender)
{
  DWORD result_;

  #ifdef MAKE_LOG           //Zapnuto logovani?
    Td_Start_Logging();           //Zapnuti logovaciho systemu do pametoveho proudu
    Td_Assign_File("make_log.txt");         //Prirazeni pametoveho proudu  k souboru (vse doposud ulozene do pameti se ulozi do souboru a dale se vse bude ukladat bezprostredne do souboru)
    Td_Insert_Log("Begin watch file:");     //Vlozim 1. vypis
  #endif


  //pokusim se inicializovat kartu zadaneho jmena
  result_=Td_Init_Driver(&PHandleKarty,"EXAM_ANALOG");
  if(result_!=0)
  {
    MessageBox(NULL,"Nenalezeno dn aktivn zazen s nzvem EXAM_ANALOG, pouijte administran program [admin.exe].","Chyba!!",MB_OK);
    resolve_error(result_);
    Application->Terminate();
    return;
  }
}

//---------------------------------------------------------------------------
void __fastcall TExample::FormClose(TObject *Sender, TCloseAction &Action)
{
  DWORD result_;
  result_=Td_Close_Driver(PHandleKarty);
  if(result_!=0)
  {
    //Nezdaen skonen komunikace, operaci nelze provst.
    resolve_error(result_);
    return;
  }

  #ifdef MAKE_LOG
    Td_StopLogging();  //Zastavim logovani
  #endif
}

//---------------------------------------------------------------------------
void __fastcall TExample::SetDOValueClick(TObject *Sender)
{
  DWORD value;
  DWORD result_;
  try
  {
    value=Edit7->Text.ToInt();
    if((value<0)||(value>255))
    {
      throw Exception("");
    }
  }
  catch(...)
  {
    ShowMessage("Do pole hodnoty digitlnho vstupu muste vyplnit slo 0..255.");
    return;
  }

  DWord buffer[32];
  char* retezec;


  result_=Td_Set_DO(PHandleKarty,0,&value,1);
  if(result_!=0)
  {
    resolve_error(result_);
    return;
  }
  Sleep(100);
}

//Procedura, ktera vytvori message box s chybovou zprvou
void TExample::resolve_error(DWORD n_error)
{
  char function_[1000];
  char error_[1000];

  Td_Get_ErrorMessage(n_error,&error_[0],&function_[0]);
  MessageBox(NULL,&function_[0],&error_[0],MB_ICONERROR);
}
