unit example_dll;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, tedia_daq01h, Registry, Math, ComCtrls,
  AppEvnts,SyncObjs;
const
  transform_mux: array[0..1] of integer = (0,31); {<EDIT>}

type


  ADWord=array of DWord;
  TAnalog = class(TForm)
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    CNT0_1: TRadioButton;
    CNT0_2: TRadioButton;
    CNT0_3: TRadioButton;
    GroupBox5: TGroupBox;
    CNT1_1: TRadioButton;
    CNT1_2: TRadioButton;
    CNT1_3: TRadioButton;
    CNT1_0: TRadioButton;
    CNT0_0: TRadioButton;
    Panel2: TPanel;
    GroupBox6: TGroupBox;
    Label2: TLabel;
    LabeledEdit2: TLabeledEdit;
    SaveDialog1: TSaveDialog;
    GroupBox8: TGroupBox;
    Edit1: TEdit;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Button5: TButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Button2: TButton;
    LabeledEdit1: TLabeledEdit;
    Button3: TButton;
    Button1: TButton;
    Button4: TButton;
    Button6: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Timer1: TTimer;
    Label5: TLabel;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
  public
    count_registry_card:DWord;
    call_buffer:PDWord;
    call_size_of_buffer:DWord;
    Fselect_file:boolean;

    procedure resolve_error(n_error:Dword); //Procedura, ktera vytvori message box s chybovou zpravou
  end;

  TPAnalog=^TAnalog;

var
  Analog: TAnalog;
  Ihandle:PHandle;
  number_of_channels:DWord;     //Pocet nastavenich kanalu
  number_of_all_channels:DWord;
  buffer:PDWord;
  state:DWord;        //Zpusob, kterym se data prijmaji 1: Active wait, 2-Passive wait
  is_running:boolean; //true-bezi mereni casovacem, nebo externi spousteni

  data_ready:TEvent;  //Signalovan kdyz jsou platne data dosud neulozene do souboru
  data_busy:TEvent;   //Signalovan kdyz jsou data ve fazi zpracovani (ukladani do souboru)

  //Informace od my_service
  file_stream:TextFile;
  global_counter:DWord;

implementation

{$R *.dfm}

procedure my_service(handle:PHandle;Pmy_body:pointer;buffer:PDWord;size_of_buffer:DWord); stdcall;
var
  i,j:integer;
  count_complete_sample:DWord;
  str:string;

begin
  try
    count_complete_sample:=size_of_buffer div number_of_channels;
    for i:=0 to count_complete_sample-1 do
    begin
      str:='';
      for j:=0 to number_of_channels-1 do
      begin                //Prekopirujeme data z bufferu do streamu prirazenemu souboru
        inc(global_counter);
        str:=str+'|'+IntToStr(ADWord(buffer)[number_of_channels*i+j]);
      end;
      str:=str+chr(13);
      Write(file_stream,str);
    end;
  except
    ShowMessage('Nepodailo se uloit pchoz data.');
    Td_Stop_Buffer_Data_Request(handle);
  end;
end;

procedure TAnalog.FormCreate(Sender: TObject);
var
  result_:DWord;
begin
  is_running:=false;

  //Otevru kartu
  result_:=Td_Init_Driver(@Ihandle,PChar('EXAM_ANALOG'));
  if result_<>0 then
  begin
    Application.MessageBox('Nenalezeno dn aktivn zazen s nzvem EXAM_ANALOG, pouijte administran program [admin.exe].','Chyba!',MB_ICONERROR);
    resolve_error(result_);
    Application.Terminate;
  end;

  Fselect_file:=false;

  data_ready:=TEvent.Create(nil,false,false,'data_ready');
  data_busy:=TEvent.Create(nil,false,true,'data_busy');
end;

procedure TAnalog.Button2Click(Sender: TObject);
var
  result_,i:DWord;
  frequency:double;
  period:double;
  requested_row:integer;
  call_every:DWord;
  CfgCNT0:integer;
  CfgCNT1:integer;
begin

  if not(Fselect_file) then
  begin
    Application.MessageBox('Nejprve vyberte soubor pro uloen dat.','Chyba!',MB_ICONERROR);
    Exit;
  end;
  
  state:=1;

  try
    number_of_channels:=StrToInt(LabeledEdit2.Text);
  except
    Application.MessageBox('Poet kanl mus bt cel kladn slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  if number_of_channels<=0 then
  begin
    Application.MessageBox('Poet kanl mus bt cel kladn slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  number_of_all_channels:=number_of_channels;
  if not(CNT0_0.Checked) then inc(number_of_all_channels);
  if not(CNT1_0.Checked) then inc(number_of_all_channels);

  try
    frequency:=StrToFloat(Edit1.Text);
  except
    Application.MessageBox('Frekvence mus bt slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  if frequency<=31 then
  begin
    Application.MessageBox('Frekvenece mus bt v interval 31Hz az 2Mhz.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  is_running:=true;

  //Nastavime analogove vstupni kanaly, zesileni zvolime pro vsechny 1x
  for i:=0 to number_of_channels-1 do
  begin
    result_:=Td_Config_Acquisition(Ihandle,i,0,i,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
  end;

  if not(CNT0_0.Checked) then //Pokud si prejeme zapnout counter(popisovac) dat ulozime kanaly 256 nebo 257
  begin
    result_:=Td_Config_Acquisition(Ihandle,256,0,number_of_channels,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
    inc(number_of_channels);
  end;

  if not(CNT1_0.Checked) then
  begin
    result_:=Td_Config_Acquisition(Ihandle,257,0,number_of_channels,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
    inc(number_of_channels);
  end;

  CfgCNT0:=0;
  CfgCNT1:=0;
  if (CNT0_0.Checked) then CfgCNT0:=0;
  if (CNT0_1.Checked) then CfgCNT0:=1;
  if (CNT0_2.Checked) then CfgCNT0:=2;
  if (CNT0_3.Checked) then CfgCNT0:=3;

  if (CNT1_0.Checked) then CfgCNT1:=0;
  if (CNT1_1.Checked) then CfgCNT1:=1;
  if (CNT1_2.Checked) then CfgCNT1:=2;
  if (CNT1_3.Checked) then CfgCNT1:=3;

  //odesleme data scan. citacum
  result_:=Td_Config_ScanCounter(Ihandle,CfgCNT0,0);
  if result_<>0 then
  begin
    //Nepodailo se nastavit popisujc ta.
    resolve_error(result_);
    Exit;
  end;
  result_:=Td_Config_ScanCounter(Ihandle,CfgCNT1,1);
  if result_<>0 then
  begin
    //Nepodailo se nastavit popisujc ta.
    resolve_error(result_);
    Exit;
  end;

  //Nastavime frekvenci
  period:=0;
  result_:=Td_Config_Timing_Acquisition(Ihandle,@frequency,@period);
  if result_<>0 then
  begin
    //Nepodailo se nastavit frekvenci tae.
    resolve_error(result_);
    Exit;
  end;

  Edit2.Text:=FloatToStr(frequency);
  Edit2.Refresh();

  //Odstarujeme mereni s SW rizenim
  result_:=Td_Start_Acquisition(Ihandle,2);
  if result_<>0 then
  begin
    //Nepodailo se odstartovat men.
    resolve_error(result_);
    Exit;
  end;

  is_running:=true;
  requested_row:=-1;
  call_every:=200;        //Nizsi cislo (100) zaruci vysokou odezvu, cislo okolo 10000 zajisti vysokou propustnost
  global_counter:=0;

  result_:=Td_Start_Buffer_Data_Request_Sync(Ihandle,my_service,requested_row,call_every,Analog);
  if result_<>0 then
  begin
    //Nepodailo se odmit vzorek.
    resolve_error(result_);
    Exit;
  end;
  Button1.Enabled:=false;
  Button4.Enabled:=false;
  Button6.Enabled:=true;

end;

procedure TAnalog.FormClose(Sender: TObject; var Action: TCloseAction);
var
  result_:DWord;
begin
  //if(is_running) then
  begin
    result_:=Td_Stop_Acquisition(Ihandle);
    if result_<>0 then
    begin
      //Nepodailo se uzavt kartu.
      resolve_error(result_);
      Exit;
    end;

    Application.ProcessMessages();

    result_:=Td_Close_Driver(Ihandle);
    if result_<>0 then
    begin
      //Nepodailo se uzavt kartu.
      resolve_error(result_);
      Exit;
    end;
    is_running:=false;
  end;

  //Uzavreme spojeni
  if(Fselect_file) then CloseFile(file_stream);
end;

procedure TAnalog.Button3Click(Sender: TObject);
var
  result_,i,j:DWord;
  frequency:double;
  period:double;
  count_new_row:DWord;

  buffer_loc:PDWord;   //Uzivatelsky buffer pro alokovane data
  size_of_buffer:DWord; //Delka uziv bufferu

  kompletnich_vzorku:DWord;

  CfgCNT0:integer;
  CfgCNT1:integer;

  str:string;

  data_fault:DWord;
  infor_cnt:DWord;
begin
  if not(Fselect_file) then
  begin
    Application.MessageBox('Nejprve vyberte soubor pro uloen dat.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  state:=2;
  try
    number_of_channels:=StrToInt(LabeledEdit2.Text);
  except
    Application.MessageBox('Poet kanl mus bt cel kladn slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  if number_of_channels<=0 then
  begin
    Application.MessageBox('Poet kanl mus bt cel kladn slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  number_of_all_channels:=number_of_channels;
  if not(CNT0_0.Checked) then inc(number_of_all_channels);
  if not(CNT1_0.Checked) then inc(number_of_all_channels);

  try
    frequency:=StrToFloat(Edit1.Text);
  except
    Application.MessageBox('Frekvence mus bt slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  if frequency<=31 then
  begin
    Application.MessageBox('Frekvenece mus bt v interval 31Hz az 2Mhz.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  //Nastavime analogove vstupni kanaly, zesileni zvolime pro vsechny 1x
  for i:=0 to number_of_channels-1 do
  begin
    result_:=Td_Config_Acquisition(Ihandle,i,0,i,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
  end;

  if not(CNT0_0.Checked) then //Pokud si prejeme zapnout counter(popisovac) dat ulozime kanaly 256 nebo 257
  begin
    result_:=Td_Config_Acquisition(Ihandle,256,0,number_of_channels,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
    inc(number_of_channels);
  end;

  if not(CNT1_0.Checked) then
  begin
    result_:=Td_Config_Acquisition(Ihandle,257,0,number_of_channels,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
    inc(number_of_channels);
  end;

  CfgCNT0:=0;
  CfgCNT1:=0;
  if (CNT0_0.Checked) then CfgCNT0:=0;
  if (CNT0_1.Checked) then CfgCNT0:=1;
  if (CNT0_2.Checked) then CfgCNT0:=2;
  if (CNT0_3.Checked) then CfgCNT0:=3;

  if (CNT1_0.Checked) then CfgCNT1:=0;
  if (CNT1_1.Checked) then CfgCNT1:=1;
  if (CNT1_2.Checked) then CfgCNT1:=2;
  if (CNT1_3.Checked) then CfgCNT1:=3;

  //Odesleme data scan. citacum
  result_:=Td_Config_ScanCounter(Ihandle,CfgCNT0,0);
  if result_<>0 then
  begin
    //Nepodailo se nastavit popisujc ta.
    resolve_error(result_);
    Exit;
  end;
  result_:=Td_Config_ScanCounter(Ihandle,CfgCNT1,0);
  if result_<>0 then
  begin
    //Nepodailo se nastavit popisujc ta.
    resolve_error(result_);
    Exit;
  end;


  //Nastavime frekvenci
  period:=0;
  result_:=Td_Config_Timing_Acquisition(Ihandle,@frequency,@period);
  if result_<>0 then
  begin
    //Nepodailo se nastavit frekvenci tae.
    resolve_error(result_);
    Exit;
  end;

  Edit2.Text:=FloatToStr(frequency);
  Edit2.Refresh();

  //Odstarujeme mereni s SW rizenim
  result_:=Td_Start_Acquisition(Ihandle,2);
  if result_<>0 then
  begin
    //Nepodailo se odstartovat men.
    resolve_error(result_);
    Exit;
  end;

  Button1.Enabled:=false;
  Button4.Enabled:=false;
  Button6.Enabled:=true;

  size_of_buffer:=100000;
  GetMem(buffer_loc,sizeof(DWord)*size_of_buffer);
  count_new_row:=0;
  is_running:=true;
  infor_cnt:=0;
  global_counter:=0;
  try

    while is_running do //Tuto smycku prerusi ukonceni formulare (OnClose nastavi is_running na false)
    begin
      //Posleme si pro data
      result_:=Td_Get_Buffer_Status(Ihandle,@count_new_row);
      if result_<>0 then
      begin
        //Nepodailo se zjistit poet hodnot v buffer.
        resolve_error(result_);
        Exit;
      end;

      size_of_buffer:=min(count_new_row,100000);
      result_:=Td_Get_Buffer_Data(Ihandle,buffer_loc,size_of_buffer,@count_new_row);
      if result_<>0 then
      begin
        //Podivam se jestli zije hlavni vlakno (nedoslo k zastaveni mereni v dusledku preplneni buffer)
        result_:=Td_Get_State_Buffer_Data_Input(Ihandle,@data_fault);
        if result_<>0 then
        begin
          //Nepodailo se namit hodnoty, z neznmho dvodu.
          resolve_error(result_);
          exit;
        end;
        case(data_fault) of
          1:
          begin
            Application.MessageBox('Hlavn provdc se zastavilo! chyba: 1','Chyba!',MB_ICONERROR);
            exit;
          end;
          2:
          begin
            Application.MessageBox('Hlavn provdc se zastavilo! chyba: 2','Chyba!',MB_ICONERROR);
            exit;
          end;
        end;

        Application.MessageBox('Nepodailo se namit hodnoty.','Chyba!',MB_ICONERROR);
        Exit;
      end;

      //Prisly nejake data?
      kompletnich_vzorku:=count_new_row div number_of_channels;
      if(kompletnich_vzorku>0) then
      begin
        for i:=0 to kompletnich_vzorku-1 do
        begin
          str:='';
          for j:=0 to number_of_channels-1 do
          begin
            inc(global_counter);
            str:=str+'|'+IntToStr(ADWord(buffer_loc)[number_of_channels*i+j]);
          end;
          str:=str+chr(13);
          Write(file_stream,str);
        end;
      end;

      inc(infor_cnt);
      if((infor_cnt mod 10)=0) then
      begin
        Application.ProcessMessages();
      end;
      sleep(10);
    end;

  except
    ShowMessage('Nepodailo se uloit pchoz data.');
  end;
end;

procedure TAnalog.Button6Click(Sender: TObject);
var
  result_:DWord;
  data_fault:DWord;
begin
  //Zastaveni prijmu dat
  if(is_running) then
  begin
    Button1.Enabled:=true;
    Button4.Enabled:=true;
    Button6.Enabled:=false;

    is_running:=false;

    //Otestujeme stav hlavniho vlakna pred skoncenim mereni
    result_:=Td_Get_State_Buffer_Data_Input(Ihandle,@data_fault);
    if result_<>0 then
    begin
      //Nepodailo se namit hodnoty, z neznmho dvodu.
      resolve_error(result_);
      Exit;
    end;

    case(data_fault) of
      1:
      begin
        Application.MessageBox('Hlavn provdc se zastavilo! chyba: 1','Chyba!',MB_ICONERROR);
      end;
      2:
      begin
        Application.MessageBox('Hlavn provdc se zastavilo! chyba: 2','Chyba!',MB_ICONERROR);
      end;
    end;

    //Ukoncime vlakno pro prijem dat, pokud je vytvoreno
    if(state=1) then
      Td_Stop_Buffer_Data_Request(Ihandle);

    //Skoncime mereni
    result_:=Td_Stop_Acquisition(Ihandle);
    if result_<>0 then
    begin
      //Nepodailo se namit hodnoty, z neznmho dvodu.
      resolve_error(result_);
      Exit;
    end;
  end
  else
    Application.MessageBox('Nejprve muste men spustit.','Chyba!',MB_ICONERROR);
end;

procedure TAnalog.Button5Click(Sender: TObject);
var
  name_file:string;
begin
  if(Fselect_file) then CloseFile(file_stream);

  SaveDialog1:=TSaveDialog.Create(Application);

  if(SaveDialog1.Execute()) then
  begin
    name_file:=SaveDialog1.FileName;
    Fselect_file:=true;
    AssignFile(file_stream,name_file);
    Rewrite(file_stream);
    SaveDialog1.Free();
  end;
end;

procedure TAnalog.Timer1Timer(Sender: TObject);
begin
  Edit3.Text:=IntToStr(global_counter div 10000);
end;

//Procedura, ktera vytvori message box s chybovou zprvou
procedure TAnalog.resolve_error(n_error:DWord);
var
  function_:array[0..1000] of char;
  error_:array[0..1000] of char;
begin
  Td_Get_ErrorMessage(n_error,PChar(@function_),PChar(@error_));
  Application.MessageBox(PChar(@error_),PChar(@function_),MB_ICONERROR);
end;


end.
